package javax.xml.crypto.dsig;

import java.io.PrintWriter;
import java.io.PrintStream;

public class XMLSignatureException extends Exception
{
    private static final long serialVersionUID = -3438102491013869995L;
    private Throwable cause;
    
    public XMLSignatureException() {
    }
    
    public XMLSignatureException(String message) {
        super(message);
    }
    
    public XMLSignatureException(String message, Throwable cause) {
        super(message);
        this.cause = cause;
    }
    
    public XMLSignatureException(Throwable cause) {
        super((cause == null) ? null : cause.toString());
        this.cause = cause;
    }
    
    @Override
    public Throwable getCause() {
        return this.cause;
    }
    
    @Override
    public void printStackTrace() {
        super.printStackTrace();
        if (this.cause != null) {
            this.cause.printStackTrace();
        }
    }
    
    @Override
    public void printStackTrace(PrintStream printStream) {
        super.printStackTrace(printStream);
        if (this.cause != null) {
            this.cause.printStackTrace(printStream);
        }
    }
    
    @Override
    public void printStackTrace(PrintWriter printWriter) {
        super.printStackTrace(printWriter);
        if (this.cause != null) {
            this.cause.printStackTrace(printWriter);
        }
    }
}
